﻿@inject ISnackbar Snackbar
@inject UserAppState UserAppState

@implements IDisposable

<MudDialog>
    <DialogContent>
        <MudText Typo="Typo.h5">Create API Key</MudText><br />
    </DialogContent>
    <DialogActions>
        <MudStack>
            <MudStack Row="true">
                <LengthValidatedTextField @bind-Text="@ApplicationName"
                                    Label="Application Name"
                                    MinLength="3"
                                    MaxLength=128>Application Name</LengthValidatedTextField>
            </MudStack>
            <MudStack Row="true">
                <PasswordTextField @bind-Password="@Password"
                                   Label="Password">Password</PasswordTextField>
            </MudStack>
            <MudStack Justify="Justify.FlexEnd" Row="true">
                <MudSwitch @bind-Value="@AllowWrites" Color="Color.Primary" Label="Allow Writes" />
            </MudStack> 
            <MudText Color="@(AllowWrites ? Color.Warning : Color.Info)" Typo="Typo.caption">
                 NOTE: Allowing writes will allow anyone with your API Key to have full access to your account
             </MudText>
            <MudText>@(Common.Spacer(75))</MudText>
            <MudStack Justify="Justify.FlexEnd" Row="true">
                <MudButton Color="Color.Secondary" Disabled="@IsCreatingAPIKey" OnClick="OnCancel">Cancel</MudButton>
                <MudButton Color="Color.Primary" Disabled="@CreateButtonDisabled" OnClick="OnCreateAPIKey">
                    @if (IsCreatingAPIKey)
                    {
                    <MudProgressCircular Class="ms-n1" Size="Size.Small" Indeterminate="true" />
                    }
                    <MudText Class="ms-2">Create</MudText>
                </MudButton>
            </MudStack>
        </MudStack>
    </DialogActions>
</MudDialog>